include ErrorShow.inc
include ../CmnHdr.inc
;**********************CODE SEGMENT*********************************
.code 

start:;START PROG HERE. 
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		
		invoke FindWindow,SADD("#32770"), SADD("Error Show")
		mov hwnd,eax
		INVOKE IsWindow,EAX
	
		.if eax
			;An instance is already running, activate it and send it the 
			;new #
			invoke SendMessage,hwnd, ESM_POKECODEANDLOOKUP, 0, 0
		
		.else
			invoke	InitCommonControls
			invoke	DialogBoxParam,hInstance,IDD_ERRORSHOW,NULL,offset DlgProc,0		
		.endif
		
		invoke	ExitProcess,NULL

;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local dwError:dword
local hlocal:dword
local hDll:dword 
		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			invoke LoadIcon,hInstance,IDI_ERRORSHOW
			push eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax		
			pop eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
			
			;Don't accept error codes more than 5 digits long
			;Edit_LimitText(GetDlgItem(hwnd, IDC_ERRORCODE), 5);
			
			;Look up the command-line passed error number
			invoke SendMessage,hWnd, ESM_POKECODEANDLOOKUP, lParam, 0
			
		.elseif eax==ESM_POKECODEANDLOOKUP
			invoke SetDlgItemInt,hWnd, IDC_ERRORCODE,wParam, FALSE
			invoke PostMessage,hWnd,WM_COMMAND,IDOK,NULL
			invoke SetForegroundWindow,hWnd
			
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			and eax,0ffffh
			.IF eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			
			.elseif eax==IDC_ALWAYSONTOP
				invoke IsDlgButtonChecked,hWnd, IDC_ALWAYSONTOP
				
				.if eax==0
					mov eax,HWND_NOTOPMOST
				.else
					mov eax,HWND_TOPMOST			
				.endif
				
				invoke SetWindowPos,hWnd,eax, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE
				
			.ELSEIF EAX==IDC_ERRORCODE
				INVOKE GetWindowTextLength,lParam
				mov ecx,eax
				push ecx				
				invoke GetDlgItem,hWnd, IDOK
				pop ecx					
				invoke EnableWindow,eax,ecx
			
			.ELSEIF eax == IDOK
				;Get the error code
				invoke GetDlgItemInt,hWnd, IDC_ERRORCODE, NULL, FALSE
				mov dwError,eax
				
				xor eax,eax
				mov hlocal,eax;Buffer that gets the error message string
				
				;Get the error code's textual description
				invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM or  FORMAT_MESSAGE_ALLOCATE_BUFFER,NULL, dwError, MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),addr hlocal, 0, NULL
				.if !eax
					;Is it a network-related error?
					invoke LoadLibraryEx,SADD("netmsg.dll"), NULL, DONT_RESOLVE_DLL_REFERENCES
					MOV hDll ,EAX
					.if eax !=NULL
						invoke FormatMessage,FORMAT_MESSAGE_FROM_HMODULE or FORMAT_MESSAGE_FROM_SYSTEM,hDll, dwError, MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),addr hlocal, 0, NULL
						invoke FreeLibrary,hDll
					.endif
				.endif
				
				.if hlocal != NULL
					invoke LocalLock,hlocal
					invoke SetDlgItemText,hWnd, IDC_ERRORTEXT,eax
					invoke LocalFree,hlocal
				.else
					invoke SetDlgItemText,hWnd, IDC_ERRORTEXT, SADD("Error number not found.")
				.ENDIF
        					
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************

end	start

